package com.example.a3;

import android.annotation.SuppressLint;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.StrictMode;
import android.util.Log;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.Locale;

public class AsyncStockNumberLoader extends AsyncTask<String, Integer, String>{

    @SuppressLint("StaticFieldLeak")
    private MainActivity mainActivity;
    private boolean firstStart;
    private static final String TAG = "AsyncStockNumberLoader";


    private String tokenKey = "sk_bfd0c04e95f0416ea936d9593b85cdc1";

    private String currentStockName;
    private String currentCompanyName;

    private static  String SYMBOL_URL = null;

    public AsyncStockNumberLoader(MainActivity mainAct, boolean firstStart) {

        this.mainActivity = mainAct;
        this.firstStart = firstStart;
        //Set url using current stock:

    }

    @Override
    protected void onPostExecute(String s) {
        //Two scenarios will arise: loading all database of the stocks, or adding new one:
        //Loading all:
        if (firstStart){
            //Add loadAllFullStocksFunction
            mainActivity.loadAllFullStocks(parseJSON(s));
        }
        else {
            Stock newStockItem = parseJSON(s);
            mainActivity.addFullStockItem(newStockItem);
        }
    }


    @Override
    protected String doInBackground(String... params) {

        String currentStockName = params[0];
        String currentCompanyName = params[1];

        String Symbol_Url = "https://cloud.iexapis.com/stable/stock/" + currentStockName + "/quote?token=sk_bfd0c04e95f0416ea936d9593b85cdc1";

        Uri dataUri = Uri.parse(Symbol_Url);
        String urlToUse = dataUri.toString();
        StringBuilder sb = new StringBuilder();

        try {
            URL url = new URL(urlToUse);

            HttpURLConnection conn = (HttpURLConnection) url.openConnection();

            Log.d(TAG, "doInBackground: ResponseCode: " + conn.getResponseCode());

            conn.setRequestMethod("GET");

            InputStream is = conn.getInputStream();
            BufferedReader reader = new BufferedReader((new InputStreamReader(is)));

            String line;
            while ((line = reader.readLine()) != null) {
                sb.append(line).append('\n');
            }

            Log.d(TAG, "doInBackground: " + sb.toString());

        } catch (Exception e) {
            Log.e(TAG, "doInBackground: ", e);
            return null;
        }

        return sb.toString();
    }


    //This will just return a single Stock item for each iteration it is called:
    private Stock parseJSON(String s) {
        try {
            JSONArray jObjMain = new JSONArray(s);
            Log.d(TAG, "doInBackground: ResponseCode: " + jObjMain);
            JSONObject jStock = (JSONObject) jObjMain.get(0);
            double price = jStock.getDouble("lastestPrice");
            double change = jStock.getDouble("change");
            double changePercent = jStock.getDouble("changePercent");
            return new Stock(currentStockName, currentCompanyName, price, change, changePercent);
        }
        catch (Exception e) {
            Log.d(TAG, "parseJSON: " + e.getMessage());
            e.printStackTrace();
        }
        return null;
    }


}
