package com.example.a3;

import android.provider.ContactsContract;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import java.util.List;

public class StockAdapter extends RecyclerView.Adapter<StockViewHolder> {

    private static final String tag = "StockAdapter";
    private List<Stock> stockList;
    private MainActivity mainAct;

    StockAdapter (List<Stock> nList, MainActivity mainA){
        this.stockList = nList;
        this.mainAct = mainA;
    }

    @NonNull
    @Override
    public StockViewHolder onCreateViewHolder (@NonNull final ViewGroup parent, int viewType){
        View itemView = LayoutInflater.from(parent.getContext()).inflate(R.layout.stock_list_row, parent, false);
        itemView.setOnClickListener(mainAct);
        itemView.setOnLongClickListener(mainAct);
        return new StockViewHolder(itemView);
    }

    @Override
    public void onBindViewHolder(@NonNull StockViewHolder holder, int position) {
        Stock stock = stockList.get(position);
        //More info needs to be added : figure out how to add information to each stock item:
        holder.symbol.setText(stock.getSymbol());
        holder.companyName.setText(stock.getCompanyName());
        holder.price.setText(Double.toString(stock.getPrice()));
        holder.priceChange.setText(Double.toString(stock.getPriceChange()));
        holder.changePercentage.setText(Double.toString(stock.getChangePercentage()));
    }

    @Override
    public int getItemCount (){

        return stockList.size();

    }
}
